'$DYNAMIC 'for some reason if you want to make an array take a full segment
'you have to make it dynamic
DEFINT A-Z
DECLARE SUB TextSearchAgain ()

DECLARE SUB TextSearch ()
DECLARE SUB FindAndDisplayAddr (MyAddr$)


DECLARE FUNCTION MatchAddr% (Addr1$, Addr2$)

DECLARE SUB UpdateHistory (filepos&)
DECLARE SUB MakeHistory (filepos&)

DECLARE SUB ReplaceMID (Text1$, tpos%, tlen%, Text2$)
DECLARE SUB GotoAddr ()
DECLARE SUB PrevProc ()

DECLARE SUB NextProc ()

DECLARE SUB FrameBack ()
DECLARE SUB LineFwd ()

DECLARE SUB LineBack ()
DECLARE SUB UnderLay ()
DECLARE SUB ActiveLay ()
DECLARE SUB FrameFwd ()
DECLARE SUB DoJump (Jump%)
DECLARE FUNCTION ConsistsOfHexDigits% ()

DECLARE SUB Overlay ()
DECLARE SUB FileSetPos (fpos&)

DECLARE SUB Display ()
DECLARE FUNCTION FileGetPos& ()

DIM SHARED Char AS STRING * 1
DIM SHARED This$
DIM SHARED jumptocount%
DIM SHARED jumpto$(1 TO 25)
DIM SHARED xoffset%
DIM SHARED History&(0 TO 16383)
DIM SHARED CurrHistory%, MaxHistory%
DIM SHARED TextSearchString$

CurrHistory% = 0: MaxHistory% = 0
OPEN COMMAND$ FOR INPUT AS #1
CLS

xoffset% = 1
DO
CLS

Display
Overlay
UnderLay
ActiveLay
LOOP

SUB ActiveLay
    
    DO
      K$ = INKEY$

    LOOP UNTIL K$ <> ""
    SELECT CASE K$
    CASE CHR$(6)'Ctrl F
      TextSearch
    CASE CHR$(0) + "="
      TextSearchAgain
    CASE CHR$(27)
       END
    CASE CHR$(7) 'Ctrl G
      GotoAddr
    CASE CHR$(0) + "t" 'ctrl + right arrow
      IF CurrHistory% < MaxHistory% THEN
         UpdateHistory FileGetPos
         CurrHistory% = CurrHistory% + 1
         FileSetPos History&(CurrHistory%)
      END IF
    CASE CHR$(0) + "s" 'ctrl + left arrow
      IF CurrHistory% > 0 THEN
        UpdateHistory FileGetPos
        CurrHistory% = CurrHistory% - 1
        FileSetPos History&(CurrHistory%)
      END IF

    CASE "0"
      IF CurrHistory% > 0 THEN
        UpdateHistory FileGetPos
        CurrHistory% = CurrHistory% - 1
        FileSetPos History&(CurrHistory%)
      END IF

    CASE "1" TO "9"
      ActiveJump% = VAL(K$)
      IF ActiveJump% <= jumptocount% THEN
        DoJump ActiveJump%
      END IF
    CASE CHR$(0) + "H"
      LineBack
    CASE CHR$(0) + "P"
      LineFwd
    CASE CHR$(0) + "I"
      FrameBack
    CASE CHR$(0) + "Q"
      FrameFwd
    CASE CHR$(0) + "M" 'r
      IF xoffset% < 32767 THEN xoffset% = xoffset% + 1
    CASE CHR$(0) + "K" 'l
      IF xoffset% > 1 THEN xoffset% = xoffset% - 1
     
      

    CASE CHR$(0) + "i" 'ALT +F2
      PrevProc
    CASE CHR$(0) + "w" 'CTRL + Home
         SEEK 1, 1
    CASE CHR$(0) + "U", CHR$(0) + "_"'Shift + F2 Ctrl +F2
      NextProc
    END SELECT
END SUB

FUNCTION ConsistsOfHexDigits%
    IF LEN(This$) = 0 THEN EXIT FUNCTION
    FOR I% = 1 TO LEN(This$)
     IF INSTR("0123456789abcdefABCDEF", MID$(This$, I%, 1)) = 0 THEN
        ConsistsOfHexDigits% = 0
        EXIT FUNCTION
     END IF
    NEXT
    ConsistsOfHexDigits% = -1
END FUNCTION

SUB Display
F& = FileGetPos
I% = 1
DO
  LINE INPUT #1, A$
  LOCATE I%, 1
  PRINT MID$(A$, xoffset%, 80);
  IF I% = 25 THEN EXIT DO
  IF (SEEK(1) >= LOF(1)) THEN EXIT DO
  I% = I% + 1
LOOP
FileSetPos F&
END SUB

SUB DoJump (Jump%)
    G& = FileGetPos
    F& = FileGetPos
   
    LINE INPUT #1, A$
    CurrAddr$ = MID$(A$, 1, 6)
    This$ = CurrAddr$
    IF ConsistsOfHexDigits THEN
      IF CurrAddr$ > jumpto$(Jump%) THEN
        SEEK 1, 1
      ELSEIF MID$(A$, 1, 6) = jumpto$(Jump%) THEN
        FileSetPos F& 'we don't want to set history if f
        EXIT SUB
      END IF
    ELSE
      SEEK 1, 1 'Just to be safe
    END IF
    DO
      F& = FileGetPos
      LINE INPUT #1, A$
      CurrAddr$ = MID$(A$, 1, 6)
      IF MatchAddr%(CurrAddr$, jumpto$(Jump%)) THEN EXIT DO
      IF (SEEK(1) >= LOF(1)) THEN
        FileSetPos G&
        EXIT SUB
      END IF
    LOOP
    FileSetPos F&
    IF F& <> G& THEN MakeHistory G&
END SUB

SUB FindAndDisplayAddr (MyAddr$)
    This$ = MyAddr$
    IF ConsistsOfHexDigits = 0 THEN EXIT SUB
    G& = FileGetPos
   
    F& = FileGetPos
    MyAddress$ = UCASE$(MyAddress$)
    LINE INPUT #1, A$
    This$ = UCASE$(LEFT$(A$, 6))
    IF ConsistsOfHexDigits THEN 'could be comment or prefix stuff
      IF This$ > MyAddr$ THEN SEEK 1, 1
    ELSE
      SEEK 1, 1 'Could be comment
      LINE INPUT #1, A$
      This$ = UCASE$(LEFT$(A$, 6))
    END IF
    DO
      IF MatchAddr%(This$, MyAddr$) THEN
        FileSetPos F&
        IF F& <> G& THEN MakeHistory G&
        EXIT SUB
      END IF
                
      IF (SEEK(1) >= LOF(1)) THEN
        FileSetPos G&
        EXIT SUB
      END IF
               F& = FileGetPos
               LINE INPUT #1, A$
               This$ = UCASE$(LEFT$(A$, 6))
           
    LOOP
END SUB

SUB FrameBack
    F& = FileGetPos
    I% = 1
    DO
      IF FileGetPos = 0 THEN EXIT SUB
      LineBack
      IF I = 25 THEN EXIT SUB
      I% = I% + 1
    LOOP
END SUB

SUB FrameFwd
I% = 1
DO
  LINE INPUT #1, A$
  IF I% = 25 THEN EXIT DO
  IF (SEEK(1) >= LOF(1)) THEN EXIT DO
  I% = I% + 1
LOOP

END SUB

SUB GotoAddr
    LOCATE 10, 1
    PRINT "Ŀ"
    PRINT "Goto:       "
    PRINT ""
    digitpos% = 1
    MyAddr$ = "      "
    DO
      LOCATE 11, 6 + digitpos%, 1
      
      This$ = INKEY$
      IF ConsistsOfHexDigits THEN
        MID$(MyAddr$, digitpos%, 1) = This$
        LOCATE 11, 7, 0
        PRINT MyAddr$
        IF digitpos% < 6 THEN digitpos = digitpos + 1
      ELSE
        SELECT CASE This$
        CASE CHR$(8)
          IF digitpos% > 1 THEN
            digitpos% = digitpos% - 1
            ReplaceMID MyAddr$, digitpos%, 1, ""
            MyAddr$ = MyAddr$ + " "
            LOCATE 11, 7, 0
            PRINT MyAddr$
          END IF
        CASE CHR$(0) + "M" 'r
          IF digitpos% < 6 THEN digitpos% = digitpos% + 1
        CASE CHR$(0) + "K" 'l
          IF digitpos% > 1 THEN digitpos% = digitpos% - 1
        CASE CHR$(27)
          EXIT SUB
        CASE CHR$(13)
          FindAndDisplayAddr MyAddr$
          EXIT SUB
        END SELECT
      END IF
    LOOP

END SUB

SUB LineBack
    IF FileGetPos = 0 THEN EXIT SUB
    F& = FileGetPos
    CLOSE 1
    OPEN COMMAND$ FOR BINARY AS 1
   
    FileSetPos F&
    F& = F& - 1
      IF F& = 0 THEN
        CLOSE 1
        OPEN COMMAND$ FOR INPUT AS 1
         EXIT SUB
      END IF

    DO
      F& = F& - 1
      FileSetPos F&
      IF F& = 0 THEN
        CLOSE 1
        OPEN COMMAND$ FOR INPUT AS 1
         EXIT SUB
      END IF
      
       
      GET 1, , Char
      IF Char = CHR$(10) THEN
        F& = FileGetPos
        CLOSE 1
        OPEN COMMAND$ FOR INPUT AS 1
        FileSetPos F&
        EXIT SUB
      END IF
    LOOP
END SUB

SUB LineFwd
    IF (SEEK(1) >= LOF(1)) THEN EXIT SUB
    LINE INPUT #1, A$
END SUB

SUB MakeHistory (filepos&)
    IF CurrHistory% = 16383 THEN EXIT SUB
    History&(CurrHistory%) = filepos&
    CurrHistory% = CurrHistory% + 1
    MaxHistory% = CurrHistory%
END SUB

FUNCTION MatchAddr% (Addr1$, Addr2$)
    IF UCASE$(Addr1$) = UCASE$(Addr2$) THEN MatchAddr% = -1
END FUNCTION

SUB NextProc
    IF (SEEK(1) = LOF(1)) THEN EXIT SUB
    G& = FileGetPos
    IF (SEEK(1) = LOF(1)) THEN
      FileSetPos G&
      EXIT SUB
    END IF
   
    LINE INPUT #1, A$
    DO
      F& = FileGetPos
      LINE INPUT #1, A$
      IF INSTR(A$, ";PROC{") THEN
        FileSetPos F&
        EXIT DO
      END IF
      IF (SEEK(1) = LOF(1)) THEN
        FileSetPos G&
        EXIT SUB
      END IF
    LOOP
END SUB

SUB Overlay
F& = FileGetPos
I% = 1
callcount% = 1
DO
  LINE INPUT #1, A$
  LOCATE I%, 1
  IF "call" = MID$(A$, 31, 4) THEN
     This$ = MID$(A$, 36, 6)
     IF ConsistsOfHexDigits THEN
        LOCATE I%, 50
        PRINT ";("; LTRIM$(STR$(callcount%)); ")";
        callcount% = callcount% + 1
     END IF
  END IF
  IF I% = 25 THEN EXIT DO
  IF (SEEK(1) = LOF(1)) THEN EXIT DO
  I% = I% + 1
LOOP
FileSetPos F&
END SUB

SUB PrevProc
    IF SEEK(1) = 1 THEN EXIT SUB
    G& = FileGetPos
    LineBack
    IF SEEK(1) = 1 THEN
      FileSetPos G&
      EXIT SUB
    END IF
   
    DO
      F& = FileGetPos
      LINE INPUT #1, A$
      IF INSTR(A$, ";PROC{") THEN
        FileSetPos F&
        EXIT DO
      END IF
      LineBack
      LineBack
      IF SEEK(1) = 1 THEN
         LINE INPUT #1, A$
         IF INSTR(A$, ";PROC{") THEN
           SEEK 1, 1
           EXIT DO
         END IF
        FileSetPos G&
        EXIT SUB
      END IF
    LOOP
END SUB

SUB ReplaceMID (Text1$, tpos%, tlen%, Text2$)
    IF Text2$ = "" THEN
       Text1$ = LEFT$(Text1$, tpos - 1) + MID$(Text1$, tpos + tlen%)
    ELSE
      MID$(Text1$, tpos%, tlen%) = Text2$
    END IF
END SUB

SUB TextSearch
    G& = FileGetPos
    LOCATE 1, 1
    PRINT SPACE$(80)
    LOCATE 1, 1
    LINE INPUT B$
    TextSearchString$ = B$
    DO
      F& = FileGetPos
      LINE INPUT #1, A$
      IF INSTR(A$, B$) THEN
         FileSetPos F&
        EXIT SUB
      END IF
      IF (SEEK(1) >= LOF(1)) THEN
        FileSetPos G&
        EXIT SUB
      END IF
    LOOP

END SUB

SUB TextSearchAgain
    G& = FileGetPos
    IF TextSearchString$ = "" THEN
      TextSearch
    ELSE
    B$ = TextSearchString$
    LINE INPUT #1, A$
    IF (SEEK(1) >= LOF(1)) THEN
      FileSetPos G&
      EXIT SUB
    END IF
   
    DO
      F& = FileGetPos
      LINE INPUT #1, A$
      IF INSTR(A$, B$) THEN
         FileSetPos F&
        EXIT SUB
      END IF
      IF (SEEK(1) >= LOF(1)) THEN
        FileSetPos G&
        EXIT SUB
      END IF
    LOOP
    END IF
END SUB

SUB UnderLay
    F& = FileGetPos
    I% = 1
    callcount% = 1
    jumptocount% = 0
    DO
      LINE INPUT #1, A$
      LOCATE I%, 1
      IF "call" = MID$(A$, 31, 4) THEN
      This$ = MID$(A$, 36, 6)
      IF ConsistsOfHexDigits THEN
        jumptocount% = jumptocount% + 1
        jumpto$(jumptocount%) = This$
        callcount% = callcount% + 1
     END IF
  END IF
  IF I% = 25 THEN EXIT DO
  IF (SEEK(1) = LOF(1)) THEN EXIT DO
  I% = I% + 1
LOOP
   
    FileSetPos F&
END SUB

SUB UpdateHistory (filepos&)
    History&(CurrHistory%) = filepos&
END SUB

